#if 0
#ifndef __SETUP
#include	"c_setup.h"
#endif
#endif

#include	<portab.h>

#if !defined(__TT)
	#if defined(__STE) || defined(__FALCON)
		#define VGA_ADR		(UBYTE *)(0xc00000L)
		#define VGA_SCREEN	(UBYTE *)(0xa00000L)
		#define IO_BASE		(UBYTE *)(0xd08000L)
	#elif defined(__MULTIBOARD)
		#define VGA_ADR		(UBYTE *)(0xc00000L)
		#define VGA_SCREEN	(UBYTE *)(0xd00000L)
		#define IO_BASE		(UBYTE *)(0xf48000L)
	#else
		#define VGA_ADR		(UBYTE *)(0x800000L)
		#define VGA_SCREEN	(UBYTE *)(0xa00000L)
		#define IO_BASE		(UBYTE *)(0x908000L)
	#endif
#else
	#define VGA_ADR		(UBYTE *)(0xfe800000L)
	#define VGA_SCREEN	(UBYTE *)(0xfea00000L)
	#define IO_BASE		(UBYTE *)(0xfe908000L)
#endif
#define SCR_SIZE1		0x200000L
#define SCR_SIZE2		128L*1024L

#define MC_SETUP		0x0102-0x8000
#define VGA_CONTROL	0x46e8-0x8000
#define ATI_EXT		0x01ce-0x8000

/* VGA-kompatible Register */
#define ATTR_CONTR	0x03c0-0x8000
#define VIDEO_ENABLE	0x03c3-0x8000
#define INP_STAT_0	0x03c2-0x8000
#define MISC_OUT_R	0x03cc-0x8000
#define MISC_OUT_W	0x03c2-0x8000
#define SEQU_CONTR	0x03c4-0x8000
#if 0
#define DAC_MASK		0x03c6-0x8000
#define DAC_READ		0x03c7-0x8000
#define DAC_WRITE		0x03c8-0x8000
#define DAC_DATA		0x03c9-0x8000
#endif
#define SEG_SELECT	0x03cd-0x8000
#define GRAPH_CONTR	0x03ce-0x8000
#define CRT_CONTR		0x03d4-0x8000
#define INP_STAT_1	0x03da-0x8000

/* 8514/A-Register */
#define DAC_MASK	0x02ea-0x8000
#define DAC_READ	0x02eb-0x8000
#define DAC_WRITE	0x02ec-0x8000
#define DAC_DATA	0x02ed-0x8000

#define ADVFUNC_CTL	0x4ae8-0x8000
#define DISP_CNTL		0x22e8-0x8000
#define H_TOTAL		0x02e8-0x8000
#define H_DISP			0x06e8-0x8000
#define H_SYNC_STRT	0x0ae8-0x8000
#define H_SYNC_WID	0x0ee8-0x8000
#define V_TOTAL		0x12e8-0x8000
#define V_DISP			0x16e8-0x8000
#define V_SYNC_STRT	0x1ae8-0x8000
#define V_SYNC_WID	0x1ee8-0x8000

#define MEM_CNTL		0xbee8-0x8000
#define SUBSYS_CNTL	0x42e8-0x8000


/* ATI-Register */
#define CLOCK_SEL			0x4aee-0x8000
#define CRT_OFFSET_HI	0x2eee-0x8000
#define CRT_OFFSET_LO	0x2aee-0x8000
#define CRT_PITCH			0x26ee-0x8000

#define SHADOW_CTL		0x46ee-0x8000
#define SHADOW_SET		0x5aee-0x8000

#define MAX_WAITSTATES	0x6aee-0x8000
#define MISC_OPTIONS		0x36ee-0x8000

#define EXT_GE_CONFIG	0x7aee-0x8000
#define GE_OFFSET_HI		0x72ee-0x8000
#define GE_OFFSET_LO		0x6eee-0x8000
#define GE_PITCH			0x76ee-0x8000

#define MEM_BNDRY			0x42ee-0x8000
#define MEM_CFG			0x5eee-0x8000

#define LOCAL_CONTROL	0x32ee-0x8000
#define MISC_CNTL			0x7eee-0x8000
#define R_MISC_CNTL		0x92ee-0x8000
#define SCRATCH_PAD_0	0x52ee-0x8000
#define SCRATCH_PAD_1	0x56ee-0x8000

/* Engineregister zum Zeichnen */
#define DP_CONFIG			0xceee-0x8000
#define EXT_FIFO_STATUS	0x9aee-0x8000
#define LINEDRAW_OPT		0xa2ee-0x8000
#define ALU_BG_FN			0xb6ee-0x8000
#define ALU_FG_FN			0xbaee-0x8000
#define BOUND_BOTTOM		0x7eee-0x8000
#define BOUNDS_LEFT		0x72ee-0x8000
#define BOUND_RIGHT		0x7aee-0x8000
#define BOUNDS_TOP		0x76ee-0x8000
#define BRES_COUNT		0x96ee-0x8000
#define DEST_CMP_FN		0xeeee-0x8000
#define DEST_X_END		0xaaee-0x8000
#define DEST_X_START		0xa6ee-0x8000
#define DEST_Y_END		0xaeee-0x8000
#define EXT_SCISSOR_B	0xe6ee-0x8000
#define EXT_SCISSOR_L	0xdaee-0x8000
#define EXT_SCISSOR_R	0xe2ee-0x8000
#define EXT_SCISSOR_T	0xdeee-0x8000
#define EXT_SHORT_STROKE	0xc6ee-0x8000
#define LINEDRAW			0xfeee-0x8000
#define LINEDRAW_INDEX	0x9aee-0x8000
#define PATT_DATA			0x8eee-0x8000
#define PATT_DATA_INDEX	0x82ee-0x8000
#define PATT_INDEX		0xd6ee-0x8000
#define PATT_LENGTH		0xd2ee-0x8000
#define R_SRC_X			0xdaee-0x8000
#define R_SRC_Y			0xdeee-0x8000
#define SCAN_X				0xcaee-0x8000
#define SRC_X_END			0xbeee-0x8000
#define SRC_X_START		0xb2ee-0x8000
#define SRC_Y_DIR			0xc2ee-0x8000
#define EXT_GE_STATUS	0x62ee-0x8000

#define BKGD_COLOR		0xa2e8-0x8000
#define BKGD_MIX			0xb6e8-0x8000
#define CMD					0x9ae8-0x8000
#define CMP_COLOR			0xb2e8-0x8000
#define CUR_X				0x86e8-0x8000
#define CUR_Y				0x82e8-0x8000
#define ERR_TERM			0x92e8-0x8000
#define FRGD_COLOR		0xa6e8-0x8000
#define FRGD_MIX			0xbae8-0x8000
#define GE_STAT			0x9ae8-0x8000
#define MAJ_AXIS_PCNT	0x96e8-0x8000
#define MIN_AXIS_PCNT	0xbee8-0x8000
#define PATTERN_H			0xbee8-0x8000
#define PATTERN_L			0xbee8-0x8000
#define PIXEL_CNTL		0xbee8-0x8000
#define PIX_TRANS			0xe2e8-0x8000
#define RD_MASK			0xaee8-0x8000
#define SCISSOR_B			0xbee8-0x8000
#define SCISSOR_L			0xbee8-0x8000
#define SCISSOR_R			0xbee8-0x8000
#define SCISSOR_T			0xbee8-0x8000
#define SHORT_STROKE		0x9ee8-0x8000
#define SRC_X				0x8ee8-0x8000
#define DESTX_DIASTP		0x8ee8-0x8000
#define SRC_Y				0x8ae8-0x8000
#define DESTY_AXSTP		0x8ae8-0x8000
#define WRT_MASK			0xaae8-0x8000

/* Overscan-Register */
#define HORZ_OVERSCAN		0x62ee-0x8000
#define VERT_OVERSCAN		0x66ee-0x8000
#define OVERSCAN_COLOR_8	0x02ee-0x8000
#define OVERSCAN_BLUE_24	0x02ef-0x8000
#define OVERSCAN_GREEN_24	0x06ee-0x8000
#define OVERSCAN_RED_24		0x06ef-0x8000

/* Statusregister */
#define CONFIG_STATUS_1		0x12ee-0x8000
#define CONFIG_STATUS_2		0x16ee-0x8000

/* DAC-Register */
#define ATT_MODE_CNTL		0x02ea-0x8000
#define OUTPUT_CLK_SEL		0x02ea-0x8000
#define MUX_CNTL				0x02eb-0x8000
#define INPUT_CLK_SEL		0x02ed-0x8000

/* CURSOR-Register */
#define CURSOR_OFFSET_HI	0x0eee-0x8000
#define CURSOR_OFFSET_LO	0x0aee-0x8000
#define HORZ_CURSOR_POSN	0x12ee-0x8000
#define VERT_CURSOR_POSN	0x16ee-0x8000
#define CURSOR_COLOR_0		0x1aee-0x8000
#define CURSOR_COLOR_1		0x1aef-0x8000
#define HORZ_CURSOR_OFFSET	0x1eee-0x8000
#define VERT_CURSOR_OFFSET	0x1eef-0x8000
#define EXT_CURSOR_COLOR_0	0x3aee-0x8000
#define EXT_CURSOR_COLOR_1	0x3eee-0x8000

/* Identifikationsregister */
#define CHIP_ID				0xfaee-0x8000
