#if 0
#ifndef __SETUP
#include	"c_setup.h"
#endif
#endif

#include	<portab.h>

#ifndef __TT
	#ifdef __FALCON
		#define VGA_ADR		(UBYTE *)(0xffa00000L)
		#define VGA_SCREEN	(UBYTE *)(0xffc00000L)
		#define IO_BASE		(UBYTE *)(0xffb08000L)
	#elif defined(__STE)
		#define VGA_ADR		(UBYTE *)(0xa00000L)
		#define VGA_SCREEN	(UBYTE *)(0xc00000L)
		#define IO_BASE		(UBYTE *)(0xb08000L)
	#elif defined(__HADES)
		#if defined(__PCI)
			#define VGA_ADR		(UBYTE *)(0x80000000L)
			#define VGA_SCREEN	(UBYTE *)(0x80400000L)
			#define IO_BASE		(UBYTE *)(0xb0008000L)
		#else
			#define VGA_ADR		(UBYTE *)(0xff000000L)
			#define VGA_SCREEN	(UBYTE *)(0xff400000L)
			#define IO_BASE		(UBYTE *)(0xfff08000L)
		#endif
	#else
		#ifdef __PANTHER
			#define VGA_ADR		(UBYTE *)(0xc00000L)
			#define VGA_SCREEN	(UBYTE *)(0x800000L)
			#define IO_BASE		(UBYTE *)(0xc08000L)
		#else
			#define VGA_ADR		(UBYTE *)(0xa00000L)
			#define VGA_SCREEN	(UBYTE *)(0xc00000L)
			#define IO_BASE		(UBYTE *)(0xb08000L)
		#endif
	#endif
#else
	#ifdef __PANTHER
		#define VGA_ADR		(UBYTE *)(0xfec00000L)
		#define VGA_SCREEN	(UBYTE *)(0xfe800000L)
		#define IO_BASE		(UBYTE *)(0xfec08000L)
	#elif defined(__MEDUSA)
		#define VGA_ADR		(UBYTE *)(0x7f000000L)
		#define VGA_SCREEN	(UBYTE *)(0x7f400000L)
		#define IO_BASE		(UBYTE *)(0x7f108000L)
	#else
		#define VGA_ADR		(UBYTE *)(0xfe800000L)
		#define VGA_SCREEN	(UBYTE *)(0xfec00000L)
		#define IO_BASE		(UBYTE *)(0xfe908000L)
	#endif
#endif
#define SCR_SIZE1		0x400000L
#define SCR_SIZE2		128L*1024L

#define DAC_MASK_VGA		0x3c6-0x8000
#define DAC_READ_VGA		0x3c7-0x8000
#define DAC_WRITE_VGA	0x3c8-0x8000
#define DAC_DATA_VGA		0x3c9-0x8000

/* VGA-kompatible Register */
#define MC_SETUP		0x0102-0x8000
#define VGA_CONTROL	0x46e8-0x8000
#define SPECIAL_REG	0x4ae8-0x8000
#define ATI_EXT		0x01ce-0x8000

#define ATTR_CONTR	0x03c0-0x8000
#define VIDEO_ENABLE	0x03c3-0x8000
#define INP_STAT_0	0x03c2-0x8000
#define MISC_OUT_R	0x03cc-0x8000
#define MISC_OUT_W	0x03c2-0x8000
#define SEQU_CONTR	0x03c4-0x8000

#define GRAPH_CONTR	0x03ce-0x8000
#define CRT_CONTR		0x03d4-0x8000
#define INP_STAT_1	0x03da-0x8000

#define IOBASE_ADDR                (0x02EC - 0x8000)


#define CRTC_H_TOTAL                         (WORD)( IOBASE_ADDR + 0x7c00 )
#define CRTC_H_DISP                          (WORD)( IOBASE_ADDR + 0x7c02 )

#define CRTC_H_SYNC_STRT                     (WORD)( IOBASE_ADDR + 0x0400 )
#define CRTC_H_SYNC_DLY                      (WORD)( IOBASE_ADDR + 0x0401 )
#define CRTC_H_SYNC_WID                      (WORD)( IOBASE_ADDR + 0x0402 )

#define CRTC_V_TOTAL                         (WORD)( IOBASE_ADDR + 0x0800 )
#define CRTC_V_DISP                          (WORD)( IOBASE_ADDR + 0x0802 )

#define CRTC_V_SYNC_STRT                     (WORD)( IOBASE_ADDR + 0x0C00 )
#define CRTC_V_SYNC_WID                      (WORD)( IOBASE_ADDR + 0x0C02 )

#define CRTC_OFFSET                          (WORD)( IOBASE_ADDR + 0x1400 )
#define CRTC_PITCH                           (WORD)( IOBASE_ADDR + 0x1402 )

#define CRTC_INT_CNTL                        (WORD)( IOBASE_ADDR + 0x1800 )

#define CRTC_GEN_CNTL                        (WORD)( IOBASE_ADDR + 0x1C00 )
#define CRTC_DBL_SCAN_EN                     0x01
#define CRTC_INTERLACE_EN                    0x02
#define CRTC_HSYNC_DIS                       0x04
#define CRTC_VSYNC_DIS                       0x08
#define CRTC_CSYNC_EN                        0x10
#define CRTC_PIX_BY_2_EN                     0x20
#define CRTC_BLANK                           0x40

#define CRTC_PIX_WIDTH                       (WORD)( IOBASE_ADDR + 0x1C01 )
#define PIX_WIDTH4                           0x01
#define PIX_WIDTH8                           0x02
#define PIX_WIDTH555                         0x03
#define PIX_WIDTH565                         0x04
#define PIX_WIDTH24                          0x05
#define PIX_WIDTH32                          0x06
#define PIX_WIDTH_MASK                       0x07

#define CRTC_FIFO                            (WORD)( IOBASE_ADDR + 0x1C02 )

#define CRTC_EXT_DISP                        (WORD)( IOBASE_ADDR + 0x1C03 )
#define CRTC_EXT_DISP_EN                     0x01
#define CRTC_EXT_EN                          0x02

#define OVR_CLR_8                            (WORD)( IOBASE_ADDR + 0x2000 )
#define OVR_CLR_B                            (WORD)( IOBASE_ADDR + 0x2001 )
#define OVR_CLR_G                            (WORD)( IOBASE_ADDR + 0x2002 )
#define OVR_CLR_R                            (WORD)( IOBASE_ADDR + 0x2003 )

#define OVR_WID_LEFT                         (WORD)( IOBASE_ADDR + 0x2400 )
#define OVR_WID_RIGHT                        (WORD)( IOBASE_ADDR + 0x2402 )
#define OVR_WID_TOP                          (WORD)( IOBASE_ADDR + 0x2800 )
#define OVR_WID_BOTTOM                       (WORD)( IOBASE_ADDR + 0x2802 )

#define SCRATCH_REG0                         (WORD)( IOBASE_ADDR + 0x4000 )
#define TEST_MEM_ADDR                        (WORD)( IOBASE_ADDR + 0x4000 )
#define SCRATCH_REG1                         (WORD)( IOBASE_ADDR + 0x4400 )
#define TEST_MEM_DATA                        (WORD)( IOBASE_ADDR + 0x4400 )

#define CLOCK_CNTL                           (WORD)( IOBASE_ADDR + 0x4800 )
#define FS2_bit                              0x04
#define FS3_bit                              0x08
#define CLOCK_SEL                            0x0f
#define CLOCK_DIV                            0x30
#define CLOCK_DIV1                           0x00
#define CLOCK_DIV2                           0x10
#define CLOCK_DIV4                           0x20
#define CLOCK_STROBE                         0x40
#define CLOCK_SERIAL_DATA                    0x80

#define BUS_CNTL1_16                         (WORD)( IOBASE_ADDR + 0x4C00 )
#define BUS_WS                               0x000F
#define BUS_ROM_WS                           0x00F0
#define BUS_ROM_PAGE                         0x000F
#define BUS_ROM_DIS                          0x1000
#define BUS_IO_16_EN                         0x2000
#define BUS_DAC_SNOOP_EN                     0x4000

#define BUS_CNTL2_16                         (WORD)( IOBASE_ADDR + 0x4C02 )
#define BUS_FIFO_WS                          000Fh

#define MEM_CNTL8                            (WORD)( IOBASE_ADDR + 0x5000 )
#define MEM_SIZE_512K                        0x0000
#define MEM_SIZE_1M                          0x0001
#define MEM_SIZE_2M                          0x0002
#define MEM_SIZE_4M                          0x0003
#define MEM_SIZE_6M                          0x0004
#define MEM_SIZE_8M                          0x0005
#define MEM_SIZE_12M                         0x0006
#define MEM_SIZE_16M                         0x0007
#define MEM_SIZK_MASK                        0x0007
#define MEM_DATA_LATCH_EN                    0x0010
#define MEM_RD_LATCH_DLY5                    0x0020
#define MEM_SD_LATCH_DLY                     0x0040
#define MEM_FULL_PLS                         0x0080

#define MEM_VGA_WP_SEL                       (WORD)( IOBASE_ADDR + 0x5400 )
#define MEM_VGA_RP_SEL                       (WORD)( IOBASE_ADDR + 0x5800 )

#define MEM_CYC_LNTH                         0x0003
#define MEM_CYC_LNTH5                        0x0000
#define MEM_CYC_LNTH6                        0x0001
#define MEM_CYC_LNTH7                        0x0002
#define MEM_SHORT_CAS_EN                     0x0004

#define MEM_BNDRY                            (WORD)( IOBASE_ADDR + 0x5002 )
#define MEM_BNDRY_256K                       0x01
#define MEM_BNDRY_512K                       0x02
#define MEM_BNDRY_1M                         0x03
#define MEM_BNDRY_EN                         0x04

#define DAC_W_INDEX                          (WORD)( IOBASE_ADDR + 0x5C00 )
#define DAC_DATA                             (WORD)( IOBASE_ADDR + 0x5C01 )
#define DAC_MASK                             (WORD)( IOBASE_ADDR + 0x5C02 )
#define DAC_R_INDEX                          (WORD)( IOBASE_ADDR + 0x5C03 )
#define DAC8_W_INDEX                         (WORD)( DAC_W_INDEX & 0xff)
#define DAC8_DATA                            (WORD)( DAC_DATA & 0xff)
#define DAC8_MASK                            (WORD)( DAC_MASK & 0xff)
#define DAC8_R_INDEX                         (WORD)( DAC_R_INDEX & 0xff)
#define DAC_READ										(WORD)( IOBASE_ADDR + 0x5C03 )
#define DAC_WRITE										(WORD)( IOBASE_ADDR + 0x5C00 )

#define DAC_CNTL1                            (WORD)( IOBASE_ADDR + 0x6000 )
#define DAC_EXT_SEL_RS2                      0x01
#define DAC_EXT_SEL_RS3                      0x02
#define DAC_CNTL2                            (WORD)( IOBASE_ADDR + 0x6001 )
#define DAC_8BIT_EN                          0x01
#define DAC_PIX_DLY_MASK                     0x06
#define DAC_PIX_DLY_0NS                      0x00
#define DAC_PIX_DLY_2NS                      0x02
#define DAC_PIX_DLY_4NS                      0x04
#define DAC_BLANK_ADJ_MASK                   0x18
#define DAC_BLANK_ADJ_0                      0x00
#define DAC_BLANK_ADJ_1                      0x08
#define DAC_BLANK_ADJ_2                      0x10

#define DAC_TYPE                             (WORD)( IOBASE_ADDR + 0x6002 )

#define GEN_TEST_CNTL                        (WORD)( IOBASE_ADDR + 0x6400 )

#define CONFIG_CNTL                          (WORD)( IOBASE_ADDR + 0x6800 )
#define CFG_MEM_AP_SIZE                      0x03
#define CFG_MEM_AP_SIZE_4M                   0x01
#define CFG_MEM_AP_SIZE_8M                   0x02
#define CFG_MEM_AP_SIZE_16M                  0x03
#define CFG_VGA_AP_EN                        0x04
#define CFG_MEM_AP_LOC                       0xFFF0

#define CONFIG_CHIP_ID                       (WORD)( IOBASE_ADDR + 0x6C00 )

#define CONFIG_STAT                          (WORD)( IOBASE_ADDR + 0x7000 )

#define GEN_TEST_CNTL                        (WORD)( IOBASE_ADDR + 0x6400 )
#define GEN_EE_DATA_OUT                      0x01
#define GEN_EE_CLOCK                         0x02
#define GEN_EE_CHIP_SEL                      0x04
#define GEN_EE_DATA_IN                       0x08
#define GEN_EE_EN                            0x10

#define GEN_TEST_CNTL2                       (WORD)( IOBASE_ADDR + 0x6402 )
#define GEN_TEST_MODE_MASK                   0x0070
#define GEN_TEST_MODE_MEM                    0x0010
#define GEN_TEST_MEM_WR_MASK                 0x0100
#define GEN_TEST_MEM_WR_READ                 0x0000
#define GEN_TEST_MEM_WR_WRITE                0x0100
#define GEN_TEST_MEM_STROBE                  0x0200


#define REFRESH800                           SCRATCH_REG0 + 1
#define REFRESH1024                          SCRATCH_REG0 + 3
#define ROMLOCATION                          SCRATCH_REG1
#define DAC_SUBTYPE                          SCRATCH_REG1 + 1       /* hi order 4 bit */
#define PITCH_INFO                           SCRATCH_REG1 + 2       /* hi order 2 bit */
#define PITCH_INFO_PSIZE                     0xc0
#define DAC_VGA_MODE                         0x80
#define PITCH_INFO_DAC                       0x10
#define PITCH_INFO_MUX2                      0x20
#define PITCH_INFO_TIOCLK                    0x08
#define PITCH_INFO_DAC0                      0x01
#define PRG_DOTCLK                           SCRATCH_REG1 + 3

#define SYNCONGREEN          0              /* 8000h */
#define GAMMA                0x4000
#define GS256                0x2000
#define DACSLEEP             0x1000
#define UNPACKED24           0              /* 00100000b */
#define C555                 0b00000001
#define C565                 0b00000010
#define RGB                  0b00000100
#define BGR                  0b00001000

/* RAM DAC TYPES */
#define BT481                0x04
#define ATT491               0x14
#define SC15026              0x24
#define MU9C1880             0x34
#define IMSG174              0x44
#define ATI68860             0x05
#define ATI68880             0x15
#define ATT498               0x16
#define STG1700              0x06
#define STG1702              0x07
#define SC15021              0x17
#define ATT21C498            0x27
#define STG1703              0x37

/* ERROR MESSAGES */
#define CANNOT_FIND_MODE_TABLE      0
#define CRTC_PROGRAM_FAILED         1
#define MODE_NOT_SUPPORTED          2
#define INVALID_MODE_NUMBER         3
#define INVALID_NUMBER              4

#define DP_WRITE_MSK		(0xb2*4)
#define CLR_CMP_CNTL		(0xc2*4)

#define STG170X_MUX8    7
