#include "res.h"
#define __vga

#include	<portab.h>
#include	"c_setup.h"
#include	"xcb.h"

/* aus HANDLER.C */
int	VDIHandler(void);			/* VDI-Funktionshandler */

/* aus OPN_CLS.C */
extern	XCB	*xcb;
extern	WORD	pl_colors[33];
void	OpenWork(VDIPB *v);		/* Open Workstation */
void	OpenVWork(VDIPB *v);		/* Open Virtual Workstation */
void	CloseWork(void);			/* Close Workstation */
										/* Close Virtual Workstation */
void	CloseVWork(VDIPB *v, WORK *work);
#if !defined __opn_cls
extern int my_ptsin[SIZE_BUFFER];
extern LINEA_VARS linea_vars;
extern WORK main_work;
extern WORK help_work;
extern int req_col[256][3];
#endif

/* aus INIT_CRD.C */
										/* VGA-Initialisierung */
WORD	InitCard(RESOLUTION *res);
										/* Umschaltung auf verschiedene phys. */
VOID	SetScreen(VOID *adr);	/* Bildschirmseiten */
VOID	GetXCBValues(VOID);		/* XCB-Werte in ICB-Werte umtragen */


/* aus FILL.C */
void	FilledArea(WORK *work);	/* ausgeflltes Polygon */
void	FilledRectangle(WORK *work);	/* ausgeflltes Rechteck */
void	SortNorm(int *data);		/* sortiert 2 Koordinaten:links unten, rechts oben */
void	SortRev(int *data);		/* sortiert 2 Koordinaten:links oben, rechts unten */
void	Bar(WORK *work);			/* Balken */
void	FilledCircle(WORK *work);/* gefllten Kreis ausgeben */
										/* Punktberechnung fr Kreis/Ellipse */
int	CalcArcPoints(WORK *work, int sangle, int eangle, int xrad, int yrad);
void	Arc(WORK *work);			/* Kreisbogen */
void	Pie(WORK *work);			/* Kreissegment */
void	Circle(WORK *work);		/* ausgefllten Kreis */
void	EllArc(WORK *work);		/* Ellipsenbogen */
void	EllPie(WORK *work);		/* Ellipsensegment */
void	Ellipse(WORK *work);		/* ausgefllte Ellipse */

/* aus FLD_FILL.C */
void	ContourFill(WORK *work);		/* Contourfill-Routine */
void	FloodFill(WORK *work);	/* Floodfill-Routine */

/* aus LINE.C */
										/* Polyline, Breite 1 */
void	PLineOne(long *ptsin, WORK *work, int count);
void	Polyline(WORK *work);	/* Polyline */

/* aus TEXT.C */
void	CharOffset(WORK *w, int *xoff, int *yoff);	/* Zeichenoffset wegen Effekte */
										/* Textausmae bestimmen */
void	TextSize(WORK *w, int *text, int count, int *width, int *height);
void	Text(WORK *work);			/* Text */
void	JustifiedText(WORK *work);	/* justierter Text */

/* aus ROUNDREC.C */
										/* Rechteck mit abgerundeten Ecken */
void	RoundedRec(WORK *work);
										/* geflltes Rechteck mit abgerundeten Ecken */
void	FilledRoundedRec(WORK *work);

/* aus MARKER.C */
void	Polymarker(WORK *work);	/* Polymarker */

/* aus SET.C */
										/* Clipping setzen */
void	SetClipping(VDIPB *v, WORK *work);
										/* Schreibmodus setzen */
int	SetWritingMode(VDIPB *v, WORK *work);
void	SetColor(VDIPB *v, WORK *work);	/* Farbe setzen */
										/* Linientyp setzen */
int	SetLineType(VDIPB *v, WORK *work);
										/* benutzerdefiniertes Linienmuster setzen */
void	SetUserLine(VDIPB *v, WORK *work);
										/* Linienbreite setzen */
int	SetLineWidth(VDIPB *v, WORK *work);
										/* Linienfarbe setzen */
int	SetLineColor(VDIPB *v, WORK *work);
										/* Aussehen von Anfangs- und Endpunkt setzen */
void	SetLineEndStyles(VDIPB *v, WORK *work);
										/* Markertyp setzen */
int	SetMarkType(VDIPB *v, WORK *work);
										/* Markergre festlegen */
int	SetMarkHeight(VDIPB *v, WORK *work);
										/* Markerfarbe setzen */
int	SetMarkColor(VDIPB *v, WORK *work);
										/* Zeichenhhe in Bildschirmpunkten setzen */
void	SetCharAbs(VDIPB *v, WORK *work);
										/* Zeichenhhe in Druckpunkten setzen */
int	SetCharPoint(VDIPB *v, WORK *work);
										/* Ausgabewinkel fr Text setzen */
int	SetCharBaseline(VDIPB *v, WORK *work);
										/* neuen Font setzen */
int	SetTextFace(VDIPB *v, WORK *work);
										/* Textfarbe setzen */
int	SetTextColor(VDIPB *v, WORK *work);
										/* Texteffekte setzen */
int	SetTextEffects(VDIPB *v, WORK *work);
										/* Textausrichtung setzen */
void	SetTextAlignment(VDIPB *v, WORK *work);
										/* Fllart setzen */
int	SetFillInterior(VDIPB *v, WORK *work);
										/* Fllstil setzen */
int	SetFillStyle(VDIPB *v, WORK *work);
										/* Fllfarbe setzen */
int	SetFillColor(VDIPB *v, WORK *work);
										/* Umrahmung fr Flchen ein-/ausschalten */
int	SetFillPerimeter(VDIPB *v, WORK *work);
										/* benutzerdefiniertes Fllmuster setzen */
void	SetUserFill(VDIPB *v, WORK *work);
void	SetInputMode(VDIPB *v);	/* Eingabemodus setzen */

/* aus RASTER.C */
void	CopyOpaque(WORK *work);				/* Copy Raster Opaque */
void	CopyTransparent(WORK *work);		/* Copy Raster Transparent */
void	TransformForm(VDIPB *v);			/* Transform Form-Routine */
void	GetPixel(VDIPB *v, WORK *work);	/* Get Pixel-Routine */

/* aus INPUT.C */
int	InputLocator(VDIPB *v);		/* Mausposition/Tastatur abfragen */
void	InputValuator(void);			/* Cursor up/down-Abfrage */
int	InputChoice(VDIPB *v);		/* Funktionstastenabfrage */
int	InputString(VDIPB *v);		/* Stringeingabe */

/* aus FONT.C */
											/* neue Fonts in System einbinden */
int	LoadFonts(VDIPB *v, WORK *work);
											/* geladene Fonts lschen */
void	UnloadFonts(VDIPB *v, WORK *work);

/* aus INQUIRE.C */
											/* erweiterte Nachfragefunktion */
void	ExtendedInquire(VDIPB *v, WORK *work);
int	InqColor(VDIPB *v, WORK *work);	/* Farbwert lesen */
											/* Attribute fr Polyline lesen */
void	InqLine(VDIPB *v, WORK *work);
											/* Attribute fr Polymarker lesen */
void	InqMarker(VDIPB *v, WORK *work);
											/* Attribute fr Fill lesen */
void	InqFill(VDIPB *v, WORK *work);
											/* Attribute fr Text lesen */
void	InqText(VDIPB *v, WORK *work);
											/* Textausmae bestimmen */
void	InqTextExtent(VDIPB *v, WORK *work);
											/* Breite eines Zeichens bestimmen */
void	InqCharWidth(VDIPB *v, WORK *work);
											/* Fontname bestimmen */
int	InqFaceName(VDIPB *v, WORK *work);
void	InqInputMode(VDIPB *v);		/* Input Modus bestimmen */
											/* Informationen ber Font lesen */
void	InqFaceInfo(VDIPB *v, WORK *work);

/* aus COOKIE.C */
										/* Routine zum Installieren eines Cookies */
void	InstallCookie(COOKIE *cookie);
void VDOCookie(long wert);

/* aus SCREEN.C */
LONG	ScreenSize(VOID);			/* Gre des Bildschims in Bytes */
LONG	ScreenOffset(VOID);		/* VGA-Offset fr einen Bildschirm */
UWORD	ScreenCount(VOID);		/* Anzahl verfgbarer Bildschirme */

/* aus LOADFONT.C */
										/* Zeichensatz fhdr durch name ersetzen */
WORD	LoadFont(BYTE *name, FONT_HDR *fhdr);
WORD	LoadInfo(VOID);

/* aus INIT_CRD.C */
WORD	InitCard(RESOLUTION *res);

/* aus CALIB.C */
VOID	InitCalib(VOID);			/* Kalibrierung initialisieren */
VOID	Calib(WORD *col);			/* VDI-Kalibrierung */
VOID	Calib1000(WORD *col);	/* VDI-Kalibrierung */
VOID	ReCalib(WORD *col);		/* VDI-Rekalibrierung */
VOID	ReCalib1000(WORD *col);	/* VDI-Rekalibrierung */
