#ifndef __DEFS
#define __DEFS

#include "GLOBALS.H"
#include	"C_WORK.H"

#define FIS_HOLLOW 0					/* Flchen leer ausfllen				*/
#define FIS_SOLID 1					/* Flchen vollstndig ausfllen		*/
#define FIS_PATTERN 2				/*    "    mit Fllmuster   "			*/
#define FIS_HATCH 3					/*    "    schraffieren					*/
#define FIS_USER 4					/* benutzerdefiniertes Fllmuster	*/

#define SIZE_BUFFER 1542			/* Gre des internen Buffers			*/
#define SIZE_SCRATCH 0x100			/* Mitte des Standardscratchbuffers */
#define SIZE_FONT 44					/* Gre des Fontheaders in Word		*/

#define SIZE_DEV_TAB 45				/* Gre der Device-Tabelle			*/
#define SIZE_INQ_TAB 45				/* Gre der Inquire-Tabelle			*/
#define SIZE_SIZ_TAB 12				/* Gre der Size-Tabelle				*/

#define MIN_LINES 32					/* minimale Anzahl Linien pro Kreis	*/
#define MAX_LINES 128				/* maximale Anzahl Linien pro Kreis	*/

#define PERIM_OFF 0					/* Rand bei ausgefllten Flchen unsichtbar */
#define PERIM_ON 1					/* Rand bei ausgefllten Flchen sichtbar */

#define MULTI_OFF 0					/* kein Multifill							*/
#define MULTI_ON 1					/* Multifill								*/

#define CLIP_OFF 0					/* Clipping aus							*/
#define CLIP_ON 1						/* Clipping an								*/

#define BEG_STYLE 0					/* Linienende fr Anfang				*/
#define END_STYLE 1					/* Linienende fr Ende					*/

#define RC_COORS 2					/* RC-Koordinatensystem					*/

#define REQ_MODE 0					/* Requestmodus fr Eingabe			*/

#define MAX_X 0						/* Index fr max. x-Koor.				*/
#define MAX_Y 1						/* Index fr max. y-Koor.				*/
#define HEIGHTS 5						/* Index fr Anzahl Texthhen			*/
#define L_STYLES 6					/* Index fr Anzahl Linienstilarten */
#define M_TYPES 8						/* Index fr Anzahl Marker-Typen		*/
#define FACES 10						/* Index fr Anzahl Fonts				*/
#define PATTERNS 11					/* Index fr Anzahl Fllmuster		*/
#define HATCHES 12					/* Index fr Anzahl Schraffuren		*/
#define COLS 13						/* Index fr Anzahl Farben				*/

#define M_POINT 0

#define PTSIN 512						/* Startindex von ptsin-Kopie in my_ptsin[] */

/* Struktur zum Addieren mit Rest */
typedef struct
{
	int	offset;						/* Additionswert							*/
	int	remain;						/* Rest 										*/
	int	rem_add;						/* Additionswert fr Restaddition 	*/
	int	*var;							/* Variable, die verndert werden soll */
}ADD;


/* negative Line-A-Variablen */
typedef struct
{
	long	reserved6;				/* reserviert (-0x38e)						*/
	FONT_HDR *cur_font;			/* Zeiger auf Header akt. Font			*/
	int	reserved5[23],			/* reserviert									*/
			m_pos_hx,				/* X-Koordinate Maus							*/
			m_pos_hy,				/* Y-Koordinate Maus							*/
			m_planes,				/* Zeichenmodus der Maus					*/
			m_cdb_bg,				/* Maus Hintergrundfarbe					*/
			m_cdb_fg,				/* Maus Vordergrundfarbe					*/
			mask_form[32],			/* Vordergrund und Maske					*/
			inq_tab[45],			/* Daten fr Extended Inquire Function	*/
			dev_tab[45],			/* Daten fr Open Workstation (intout)	*/
			gcurx,					/* X-Position Maus							*/
			gcury,					/* Y-Position Maus							*/
			m_hid_ct,				/* Anzahl der hide_mouse-calls			*/
			mouse_bt,				/* Status der Mausknpfe					*/
			req_col[16][3],		/* Interne Daten fr vq_color()			*/
			siz_tab[15],			/* Daten fr Open Workstation (ptsout)	*/
			reserved4,				/* reserviert									*/
			mod_cho;					/* Input Mode Choice							*/
	WORK	*cur_work;				/* Zeiger Attribute der akt. Workstn.	*/
	FONT_HDR *def_font;			/* Standard Systemzeichensatz				*/
	FONT_HDR *font_ring[4];		/* Zeichensatzlisten							*/
	int	font_count,				/* Anzahl der Zeichenstze					*/
			reserved7,
			mod_loc,					/* Input Mode Locator						*/
			reserved3[41];			/* reserviert									*/
	int	mod_str,					/* Input Mode String							*/
			mod_val;					/* Input Mode Valuator						*/
	char	cur_ms_stat,			/* Mausstatus									*/
			reserved2;				/* reserviert									*/
	int	v_hid_cnt,				/* Anzahl der Hide_cursor-Calls			*/
			cur_x,					/* X-Position Maus frs Zeichnen			*/
			cur_y;					/* Y-Position Maus frs Zeichnen			*/
	char	cur_flag,				/* != 0: Maus neu zeichnen					*/
			mouse_flag;				/* != 0: Maus-Interrupt ein				*/
	long	reserved1;				/* reserviert									*/
	int	v_sav_xy[2],			/* gerettete X-Y-Koordinaten				*/
			save_len;				/* Anzahl der Bildschirmzeilen			*/
	void	*save_addr;				/* Erstes Byte im Bildspeicher			*/
	int	save_stat;				/* Dirty-Flag									*/
	char	save_area[256];		/* Buffer fr Bild unter Maus				*/
	void	(*user_tim)( void );	/* Timer-Interrupt-Vektor					*/
	void	(*next_tim)( void );	/* alter Interrupt							*/
	void	(*user_but)( void );	/* Maustasten-Vektor							*/	
	void	(*user_cur)( void );	/* Maus-Vektor									*/
	void	(*user_mot)( void );	/* Mausbewegungs-Vektor						*/
	int	v_cel_ht,				/* Zeichenhhe									*/
			v_cel_mx,				/* maximale Cursorspalte					*/
			v_cel_my,				/* maximale Cursorzeile						*/
			v_cel_wr,				/* Characterzeilenbreite					*/
			v_col_bg,				/* Hintergrundfarbe							*/
			v_col_fg;				/* Vordergrundfarbe							*/
	void	*v_cur_ad;				/* Adresse der Cursorposition				*/
	int	v_cur_off,				/* Vertikaler Bildschirmoffset			*/
			v_cur_xy[2];			/* X-Y-Cursor									*/
	char	v_period,				/* Blinkgeschwindigkeit (Textcursor)	*/
			v_cur_ct;				/* Zhler fr Blinken						*/
	void	*v_fnt_ad;				/* Zeiger auf Font							*/
	int	v_fnt_nd,				/* grter ASCII-Wert						*/
			v_fnt_st,				/* kleinster ASCII-Wert						*/
			v_fnt_wd,				/* Breite des Fontimage in Byte			*/
			v_rez_hz,				/* Bildschirmbreite in Pixel				*/
			*v_off_ad,				/* Font-Offset-Tabelle						*/
			v_cur_flag,				/* Cursorflag									*/
			v_rez_vt,				/* Bildschirmhhe in Pixel					*/
			bytes_lin;				/* Bytes pro Pixelzeile						*/
} VDIESC;

/* Positive Line-A-Variablen */
typedef struct
{
	int	v_planes,				/* # Bitplanes 								*/
			v_lin_wr,				/* # Bytes/Scanline 							*/
			*contrl,
			*intin,
			*ptsin,					/* Koordinaten-Eingabe						*/
			*intout,
			*ptsout,					/* Koordinaten-Ausgabe						*/
			fg_bp_1,					/* Farbbit fr Plane 0						*/
			fg_bp_2,					/* Farbbit fr Plane 1						*/
			fg_bp_3,					/* Farbbit fr Plane 2						*/
			fg_bp_4,					/* Farbbit fr Plane 3						*/
			lstlin;
	unsigned ln_mask;				/* Linienmuster								*/
	int	wrt_mode,				/* Schreib-Modus								*/
			x1, y1, x2, y2; 		/* Koordinaten									*/
	UINT	*patptr,					/* Fllmuster									*/
			patmsk;					/* .. dazugehrige Maske					*/
	int	multifill,				/* Fllmuster fr 1 Plane (0), sonst mehrere */
			clip,						/* Flag fr Clipping (0 = aus, sonst ein) */
			xmn_clip, ymn_clip,
			xmx_clip, ymx_clip, 	/* Clipping Rechteck							*/
	/* Rest fr text_blt: */
			xacc_dda;
	UINT	dda_inc;					/* Vergrerungsfaktor						*/
	int	t_sclsts,				/* Vergrerungsrichtung					*/
			mono_status,			/* Proportionalschrift						*/
			sourcex, sourcey,		/* Koordinaten im Font						*/
			destx, desty,			/* Bildschirmkoordinaten					*/
			delx, dely;				/* Breite und Hhe des Zeichen			*/
	FONT_HDR *fbase;				/* Start der Font-Daten						*/
	int	fwidth,					/* Breite des Fontimage						*/
			style;					/* Schreibstil									*/
	unsigned litemask,			/* Maske fr Light							*/
				skewmask;			/* Maske fr Kursiv							*/
	int	weight,					/* Breite bei Bold							*/
			r_off,					/* Kursiv-Offset rechts						*/
			l_off,					/* Kursiv-Offset links						*/
			scale,					/* Vergrerung ja/nein						*/
			chup,						/* Text-Rotationswinkel in 1/10 Grad	*/
			text_fg;					/* Textfarbe									*/
	void	*scrtchp;				/* Scratch-Puffer								*/
	int	scrpt2,					/* Index fr Mitte des Scratch-Puffers	*/
			text_bg,					/* unbenutzt									*/
			copy_tran,				/* != 0: Copy Transparent					*/
			(*fill_abort)(void);	/* Testet Seed Fill Abbruch (D0 != 0)	*/
} LINEA;


/* alle Line-A-Variablen */
typedef struct
{
	VDIESC vdiesc;
	LINEA linea;
} LINEA_VARS;


typedef struct
{
	void *fd_addr;							/* Zeiger auf den Beginn des*/
												/* Speicherbereichs, z. B.  */
												/* Bildspeicherbasisadresse */
	int  fd_w;								/* Blockbreite in Pixeln    */
	int  fd_h;								/* Hhe des Blocks in Pixeln*/
	int  fd_wdwidth;						/* Blockbreite in Integern  */
	int  fd_stand;							/* 0 = gerteabhngiges Format
													1 = Standardformat       */
	int  fd_nplanes;						/* Anzahl der Farbebenen    */
	int  fd_r1, fd_r2, fd_r3;			/* reserviert               */
} MFDB;


typedef struct
{
	long	id;								/* Cookie-ID */
	long	value;							/* beliebiger Wert */
} COOKIE;


typedef struct
{
	int	*contrl;							/* control-Array */
	int	*intin;							/* intin-Array */
	int	*ptsin;							/* ptsin-Array */
	int	*intout;							/* intout-Array */
	int	*ptsout;							/* ptsout-Array */
} VDIPB;

#endif
