/* 3C4, Index 7, Bit 6 */
/* 3C0, Index $10 */
#include	<portab.h>
#include	"C_SETUP.H"
#include	"C_VGA.H"
#include	"DEFS.H"
#include	"RES.H"						/* Aufbau einer Auflsungsstruktur */
#include	"em_prot.h"

#define abs(a) (a<0 ? -a:a)

UWORD	rolw(UWORD val, UWORD shift) 0xE378;


static int	ConvFreqInt(int freq);
static void	SetValues(UBYTE *io_base, int base, UBYTE *data, char start, char count);
static void	SetAttribute(UBYTE *io_base);
static void	SeqReset(UBYTE *io_base);
static void	BasicInit(RESOLUTION *res, UBYTE *io_base);
void TestForBios(UBYTE *io_base, UBYTE *vga_screen);
static void waitTime(void);

WORD	dac_type = -1;									/* DAC-Typ auf Karte */

static RESOLUTION	standard =
			{
				"",									/* Name */
				0,
				1,										/* Auflsungsart */
				80,									/* Bytes/Zeile */
				1,										/* Anzahl Planes */
				2,										/* Anzahl Farben */
				1,										/* Hardcopymodus */
				639, 399,							/* max. Koordinaten */
				639, 399,							/* reale Auflsung */
				25,									/* Frequenz */
#if (CARD_TYPE == 3) || (CARD_TYPE == 4) || (CARD_TYPE == 5) || \
	 (CARD_TYPE == 8)
				0x80, 0,								/* Low-Res, Frequenzteiler */
#else
				0x00, 0,								/* Low-Res, Frequenzteiler */
#endif
				0x63,									/* 3C2 */
				{0x5F, 0x4F, 0x50, 0x82, 0x54, 0x80, 0xBF, 0x1F,
				 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				 0x9C, 0x0E, 0x8F, 0x28, 0x00, 0xE7, 0x04, 0xC3,
				 0xFF},
				{0x00, 0x00, 0x00}				/* erweiterte 3D4-Werte */
			};


UBYTE	sequ_values[] =						/* Initialisierung fr Sequenzer */
		{0x01, 0x0F, 0x00, 0x06, 0x00, 0xB4};
static UBYTE	graph_values[] =						/* Initialisierung fr Graphik-Controller */
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 0x01,
		 0x0f, 0xff};
static UBYTE	attr_values[] =						/* Initialisierung fr Attribut-Controller */
		{0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
		 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
		 0x01, 0xFF, 0x0F, 0x10, 0x00, 0x05, 0x00};

UBYTE	color0[3] = {0xff, 0xff, 0xff};

static void	SetValues(UBYTE *io_base, int base, UBYTE *data, char start, char count)
{
	char	i;
	
	for (i = start; i < start+count; i++)	/* alle Daten schreiben */
	{
		*(io_base + base) = i;					/* Index schreiben */
		*(io_base + base + 1) = *data++;		/* Daten schreiben */
	}
}


static void	SeqReset(UBYTE *io_base)
{
	*(io_base + SEQU_CONTR) = 0;				/* Sequenzer in Resetzustand */
	*(io_base + SEQU_CONTR + 1) = 1;
	
	*(io_base + SEQU_CONTR) = 0;				/* und wieder Normalzustand */
	*(io_base + SEQU_CONTR + 1) = 3;
}

static void	SeqResetStart(UBYTE *io_base)
{
	*(io_base + SEQU_CONTR) = 0;				/* Sequenzer in Resetzustand */
	*(io_base + SEQU_CONTR + 1) = 1;
}

static void	SeqResetEnd(UBYTE *io_base)
{
	*(io_base + SEQU_CONTR) = 0;				/* und wieder Normalzustand */
	*(io_base + SEQU_CONTR + 1) = 3;
}


#include	"initati2.c"


/******************************************************************/
/* Name: ConvFreqInt																*/
/* Funktion: berechnet zu einer Frequenz (Integer) den zugehrigen*/
/*				 Index in der Frequenztabelle									*/
/******************************************************************/
static int	ConvFreqInt(int freq)
{
	WORD	i,
			dif = 9999,
			result;
													/* aktuelle Frequenz in Tabelle suchen */
	for (i = 0; i < (WORD)(sizeof(freq_tab)/sizeof(WORD)/3); i++)
		if (abs(freq_tab[i * 3] - freq) < dif)
		{
			dif = abs(freq_tab[i * 3] - freq);
			result = i;
		}
	
	return(result);							/* bestimmten Wert zurckgeben */
}

static void waitTime(void)
{
	int	i;
	
	for (i = 0; i < 3; i++);
}
